chiark / gitweb /
tmpfiles: don't allow label_fix to print ENOENT when we want to ignore it
[elogind.git] / test / test-functions
index 5fdf0a18bd72679662cf5dc8ab82cad45ca76d9c..a9446e514a81f3d34df0b9ba521b430d5a610e6a 100644 (file)
 PATH=/sbin:/bin:/usr/sbin:/usr/bin
 export PATH
 
-setup_basic_dirs() {
-    for d in usr/bin usr/sbin bin etc lib "$libdir" sbin tmp usr var var/log; do
-        [[ -e "${initdir}${prefix}/$d" ]] && continue
-        if [ -L "/$d" ]; then
-            inst_symlink "/$d" "${prefix}/$d"
-        else
-            mkdir -m 0755 -p "${initdir}${prefix}/$d"
-        fi
+KERNEL_VER=${KERNEL_VER-$(uname -r)}
+KERNEL_MODS="/lib/modules/$KERNEL_VER/"
+
+BASICTOOLS="sh bash setsid loadkeys setfont login sushell sulogin gzip sleep echo mount umount cryptsetup date dmsetup modprobe"
+DEBUGTOOLS="df free ls stty cat ps ln ip route dmesg dhclient mkdir cp ping dhclient strace less grep id tty touch du sort"
+
+function find_qemu_bin() {
+    # SUSE and Red Hat call the binary qemu-kvm
+    # Debian and Gentoo call it kvm
+    [ "$QEMU_BIN" ] || QEMU_BIN=$(which -a kvm qemu-kvm 2>/dev/null | grep '^/' -m1)
+
+    [ "$ARCH" ] || ARCH=$(uname -m)
+    case $ARCH in
+    x86_64)
+        # QEMU's own build system calls it qemu-system-x86_64
+        [ "$QEMU_BIN" ] || QEMU_BIN=$(which -a qemu-system-x86_64 2>/dev/null | grep '^/' -m1)
+        ;;
+    i*86)
+        # new i386 version of QEMU
+        [ "$QEMU_BIN" ] || QEMU_BIN=$(which -a qemu-system-i386 2>/dev/null | grep '^/' -m1)
+
+        # i386 version of QEMU
+        [ "$QEMU_BIN" ] || QEMU_BIN=$(which -a qemu 2>/dev/null | grep '^/' -m1)
+        ;;
+    esac
+
+    if [ ! -e "$QEMU_BIN" ]; then
+        echo "Could not find a suitable QEMU binary" >&2
+        return 1
+    fi
+}
+
+run_qemu() {
+    [ "$KERNEL_BIN" ] || KERNEL_BIN=/boot/vmlinuz-$KERNEL_VER
+    [ "$INITRD" ]     || INITRD=/boot/initramfs-${KERNEL_VER}.img
+    [ "$QEMU_SMP" ]   || QEMU_SMP=1
+
+    find_qemu_bin || return 1
+
+    KERNEL_APPEND="root=/dev/sda1 \
+systemd.log_level=debug \
+raid=noautodetect \
+loglevel=2 \
+init=/usr/lib/systemd/systemd \
+ro \
+console=ttyS0 \
+selinux=0 \
+$KERNEL_APPEND \
+"
+
+    QEMU_OPTIONS="-machine accel=kvm:tcg \
+-smp $QEMU_SMP \
+-net none \
+-m 512M \
+-nographic \
+-kernel $KERNEL_BIN \
+"
+
+    if [ "$INITRD" ]; then
+        QEMU_OPTIONS="$QEMU_OPTIONS -initrd $INITRD"
+    fi
+
+    $QEMU_BIN $QEMU_OPTIONS -append "$KERNEL_APPEND" $TESTDIR/rootdisk.img || return 1
+}
+
+run_nspawn() {
+    ../../systemd-nspawn --boot --directory=$TESTDIR/nspawn-root /usr/lib/systemd/systemd
+}
+
+setup_basic_environment() {
+    # create the basic filesystem layout
+    setup_basic_dirs
+
+    install_systemd
+    install_missing_libraries
+    install_config_files
+    create_rc_local
+    install_basic_tools
+    install_libnss
+    install_pam
+    install_dbus
+    install_fonts
+    install_keymaps
+    install_terminfo
+    install_execs
+    install_plymouth
+    install_debug_tools
+    install_ld_so_conf
+    strip_binaries
+    install_depmod_files
+    generate_module_dependencies
+    # softlink mtab
+    ln -fs /proc/self/mounts $initdir/etc/mtab
+}
+
+install_dmevent() {
+    instmods dm_crypt =crypto
+    type -P dmeventd >/dev/null && dracut_install dmeventd
+    inst_libdir_file "libdevmapper-event.so*"
+    inst_rules 10-dm.rules 13-dm-disk.rules 95-dm-notify.rules
+}
+
+install_systemd() {
+    # install compiled files
+    (cd $TEST_BASE_DIR/..; make DESTDIR=$initdir install)
+    # remove unneeded documentation
+    rm -fr $initdir/usr/share/{man,doc,gtk-doc}
+    # we strip binaries since debug symbols increase binaries size a lot
+    # and it could fill the available space
+    strip_binaries
+}
+
+install_missing_libraries() {
+    # install possible missing libraries
+    for i in $initdir/{sbin,bin}/* $initdir/lib/systemd/*; do
+        inst_libs $i
+    done
+}
+
+create_empty_image() {
+    rm -f "$TESTDIR/rootdisk.img"
+    # Create the blank file to use as a root filesystem
+    dd if=/dev/null of="$TESTDIR/rootdisk.img" bs=1M seek=200
+    LOOPDEV=$(losetup --show -P -f $TESTDIR/rootdisk.img)
+    [ -b "$LOOPDEV" ] || return 1
+    echo "LOOPDEV=$LOOPDEV" >> $STATEFILE
+    sfdisk -C 6400 -H 2 -S 32 -L "$LOOPDEV" <<EOF
+,3200
+,
+EOF
+
+    mkfs.ext3 -L systemd "${LOOPDEV}p1"
+}
+
+check_result_nspawn() {
+    ret=1
+    [[ -e $TESTDIR/nspawn-root/testok ]] && ret=0
+    [[ -f $TESTDIR/nspawn-root/failed ]] && cp -a $TESTDIR/nspawn-root/failed $TESTDIR
+    cp -a $TESTDIR/nspawn-root/var/log/journal $TESTDIR
+    [[ -f $TESTDIR/failed ]] && cat $TESTDIR/failed
+    ls -l $TESTDIR/journal/*/*.journal
+    test -s $TESTDIR/failed && ret=$(($ret+1))
+    return $ret
+}
+
+strip_binaries() {
+    ddebug "Strip binaries"
+    find "$initdir" -executable -not -path '*/lib/modules/*.ko' -type f | xargs strip --strip-unneeded | ddebug
+}
+
+create_rc_local() {
+    mkdir -p $initdir/etc/rc.d
+    cat >$initdir/etc/rc.d/rc.local <<EOF
+#!/bin/bash
+exit 0
+EOF
+    chmod 0755 $initdir/etc/rc.d/rc.local
+}
+
+install_execs() {
+    # install any Execs from the service files
+    egrep -ho '^Exec[^ ]*=[^ ]+' $initdir/lib/systemd/system/*.service \
+        | while read i; do
+        i=${i##Exec*=}; i=${i##-}
+        inst $i
     done
+}
+
+generate_module_dependencies() {
+    if [[ -d $initdir/lib/modules/$KERNEL_VER ]] && \
+        ! depmod -a -b "$initdir" $KERNEL_VER; then
+            dfatal "\"depmod -a $KERNEL_VER\" failed."
+            exit 1
+    fi
+}
+
+install_depmod_files() {
+    inst /lib/modules/$KERNEL_VER/modules.order
+    inst /lib/modules/$KERNEL_VER/modules.builtin
+}
+
+install_plymouth() {
+    # install plymouth, if found... else remove plymouth service files
+    # if [ -x /usr/libexec/plymouth/plymouth-populate-initrd ]; then
+    #     PLYMOUTH_POPULATE_SOURCE_FUNCTIONS="$TEST_BASE_DIR/test-functions" \
+    #         /usr/libexec/plymouth/plymouth-populate-initrd -t $initdir
+    #         dracut_install plymouth plymouthd
+    # else
+        rm -f $initdir/{usr/lib,etc}/systemd/system/plymouth* $initdir/{usr/lib,etc}/systemd/system/*/plymouth*
+    # fi
+}
+
+install_ld_so_conf() {
+    cp -a /etc/ld.so.conf* $initdir/etc
+    ldconfig -r "$initdir"
+}
+
+install_config_files() {
+    inst /etc/sysconfig/init
+    inst /etc/passwd
+    inst /etc/shadow
+    inst /etc/group
+    inst /etc/shells
+    inst /etc/nsswitch.conf
+    inst /etc/pam.conf
+    inst /etc/securetty
+    inst /etc/os-release
+    inst /etc/localtime
+    # we want an empty environment
+    > $initdir/etc/environment
+    > $initdir/etc/machine-id
+    # set the hostname
+    echo systemd-testsuite > $initdir/etc/hostname
+    # fstab
+    cat >$initdir/etc/fstab <<EOF
+LABEL=systemd           /       ext3    rw 0 1
+EOF
+}
+
+install_basic_tools() {
+    [[ $BASICTOOLS ]] && dracut_install $BASICTOOLS
+}
+
+install_debug_tools() {
+    [[ $DEBUGTOOLS ]] && dracut_install $DEBUGTOOLS
+}
+
+install_libnss() {
+    # install libnss_files for login
+    inst_libdir_file "libnss_files*"
+}
+
+install_dbus() {
+    inst /usr/lib/systemd/system/dbus.socket
+    inst /usr/lib/systemd/system/dbus.service
+
+    find \
+        /etc/dbus-1 -xtype f \
+        | while read file; do
+        inst $file
+    done
+}
+
+install_pam() {
+    find \
+        /etc/pam.d \
+        /etc/security \
+        /lib64/security \
+        /lib/security -xtype f \
+        | while read file; do
+        inst $file
+    done
+}
+
+install_keymaps() {
+    for i in \
+        /usr/lib/kbd/keymaps/include/* \
+        /usr/lib/kbd/keymaps/i386/include/* \
+        /usr/lib/kbd/keymaps/i386/qwerty/us.*; do
+            [[ -f $i ]] || continue
+            inst $i
+    done
+}
+
+install_fonts() {
+    for i in \
+        /usr/lib/kbd/consolefonts/latarcyrheb-sun16*; do
+            [[ -f $i ]] || continue
+            inst $i
+    done
+}
 
-    for d in dev proc sys sysroot root run run/lock run/initramfs; do
+install_terminfo() {
+    for _terminfodir in /lib/terminfo /etc/terminfo /usr/share/terminfo; do
+        [ -f ${_terminfodir}/l/linux ] && break
+    done
+    dracut_install -o ${_terminfodir}/l/linux
+}
+
+setup_testsuite() {
+    cp $TEST_BASE_DIR/{testsuite.target,end.service} $initdir/etc/systemd/system/
+
+    mkdir -p $initdir/etc/systemd/system/testsuite.target.wants
+    ln -fs $TEST_BASE_DIR/testsuite.service $initdir/etc/systemd/system/testsuite.target.wants/testsuite.service
+    ln -fs $TEST_BASE_DIR/end.service $initdir/etc/systemd/system/testsuite.target.wants/end.service
+
+    # make the testsuite the default target
+    ln -fs testsuite.target $initdir/etc/systemd/system/default.target
+}
+
+setup_nspawn_root() {
+    rm -fr $TESTDIR/nspawn-root
+    ddebug "cp -ar $initdir $TESTDIR/nspawn-root"
+    cp -ar $initdir $TESTDIR/nspawn-root
+    # we don't mount in the nspawn root
+    rm -f $TESTDIR/nspawn-root/etc/fstab
+}
+
+setup_basic_dirs() {
+    mkdir -p $initdir/run
+    mkdir -p $initdir/etc/systemd/system
+    mkdir -p $initdir/var/log/journal
+
+    for d in usr/bin usr/sbin bin etc lib "$libdir" sbin tmp usr var var/log dev proc sys sysroot root run run/lock run/initramfs; do
         if [ -L "/$d" ]; then
             inst_symlink "/$d"
         else
-            mkdir -m 0755 -p "$initdir/$d"
+            inst_dir "/$d"
         fi
     done
 
@@ -61,6 +354,11 @@ import_testdir() {
     fi
 }
 
+import_initdir() {
+    initdir=$TESTDIR/root
+    export initdir
+}
+
 ## @brief Converts numeric logging level to the first letter of level name.
 #
 # @param lvl Numeric logging level in range from 1 to 6.
@@ -127,9 +425,9 @@ dtrace() {
 # @param msg Message.
 # @retval 0 It's always returned, even if logging failed.
 ddebug() {
-    set +x
+#    set +x
     dlog 5 "$@"
-    [ -n "$debug" ] && set -x || :
+#    [ -n "$debug" ] && set -x || :
 }
 
 ## @brief Logs message at INFO level (4)
@@ -157,9 +455,9 @@ dwarn() {
 # @param msg Message.
 # @retval 0 It's always returned, even if logging failed.
 derror() {
-    set +x
+#    set +x
     dlog 2 "$@"
-    [ -n "$debug" ] && set -x || :
+#    [ -n "$debug" ] && set -x || :
 }
 
 ## @brief Logs message at FATAL level (1)
@@ -547,6 +845,228 @@ dracut_install() {
     done
 }
 
+# Install a single kernel module along with any firmware it may require.
+# $1 = full path to kernel module to install
+install_kmod_with_fw() {
+    # no need to go further if the module is already installed
+
+    [[ -e "${initdir}/lib/modules/$KERNEL_VER/${1##*/lib/modules/$KERNEL_VER/}" ]] \
+        && return 0
+
+    [[ -e "$initdir/.kernelmodseen/${1##*/}" ]] && return 0
+
+    if [[ $omit_drivers ]]; then
+        local _kmod=${1##*/}
+        _kmod=${_kmod%.ko}
+        _kmod=${_kmod/-/_}
+        if [[ "$_kmod" =~ $omit_drivers ]]; then
+            dinfo "Omitting driver $_kmod"
+            return 1
+        fi
+        if [[ "${1##*/lib/modules/$KERNEL_VER/}" =~ $omit_drivers ]]; then
+            dinfo "Omitting driver $_kmod"
+            return 1
+        fi
+    fi
+
+    [ -d "$initdir/.kernelmodseen" ] && \
+        > "$initdir/.kernelmodseen/${1##*/}"
+
+    inst_simple "$1" "/lib/modules/$KERNEL_VER/${1##*/lib/modules/$KERNEL_VER/}" \
+        || return $?
+
+    local _modname=${1##*/} _fwdir _found _fw
+    _modname=${_modname%.ko*}
+    for _fw in $(modinfo -k $KERNEL_VER -F firmware $1 2>/dev/null); do
+        _found=''
+        for _fwdir in $fw_dir; do
+            if [[ -d $_fwdir && -f $_fwdir/$_fw ]]; then
+                inst_simple "$_fwdir/$_fw" "/lib/firmware/$_fw"
+                _found=yes
+            fi
+        done
+        if [[ $_found != yes ]]; then
+            if ! grep -qe "\<${_modname//-/_}\>" /proc/modules; then
+                dinfo "Possible missing firmware \"${_fw}\" for kernel module" \
+                    "\"${_modname}.ko\""
+            else
+                dwarn "Possible missing firmware \"${_fw}\" for kernel module" \
+                    "\"${_modname}.ko\""
+            fi
+        fi
+    done
+    return 0
+}
+
+# Do something with all the dependencies of a kernel module.
+# Note that kernel modules depend on themselves using the technique we use
+# $1 = function to call for each dependency we find
+#      It will be passed the full path to the found kernel module
+# $2 = module to get dependencies for
+# rest of args = arguments to modprobe
+# _fderr specifies FD passed from surrounding scope
+for_each_kmod_dep() {
+    local _func=$1 _kmod=$2 _cmd _modpath _options _found=0
+    shift 2
+    modprobe "$@" --ignore-install --show-depends $_kmod 2>&${_fderr} | (
+        while read _cmd _modpath _options; do
+            [[ $_cmd = insmod ]] || continue
+            $_func ${_modpath} || exit $?
+            _found=1
+        done
+        [[ $_found -eq 0 ]] && exit 1
+        exit 0
+    )
+}
+
+# filter kernel modules to install certain modules that meet specific
+# requirements.
+# $1 = search only in subdirectory of /kernel/$1
+# $2 = function to call with module name to filter.
+#      This function will be passed the full path to the module to test.
+# The behavior of this function can vary depending on whether $hostonly is set.
+# If it is, we will only look at modules that are already in memory.
+# If it is not, we will look at all kernel modules
+# This function returns the full filenames of modules that match $1
+filter_kernel_modules_by_path () (
+    local _modname _filtercmd
+    if ! [[ $hostonly ]]; then
+        _filtercmd='find "$KERNEL_MODS/kernel/$1" "$KERNEL_MODS/extra"'
+        _filtercmd+=' "$KERNEL_MODS/weak-updates" -name "*.ko" -o -name "*.ko.gz"'
+        _filtercmd+=' -o -name "*.ko.xz"'
+        _filtercmd+=' 2>/dev/null'
+    else
+        _filtercmd='cut -d " " -f 1 </proc/modules|xargs modinfo -F filename '
+        _filtercmd+='-k $KERNEL_VER 2>/dev/null'
+    fi
+    for _modname in $(eval $_filtercmd); do
+        case $_modname in
+            *.ko) "$2" "$_modname" && echo "$_modname";;
+            *.ko.gz) gzip -dc "$_modname" > $initdir/$$.ko
+                $2 $initdir/$$.ko && echo "$_modname"
+                rm -f $initdir/$$.ko
+                ;;
+            *.ko.xz) xz -dc "$_modname" > $initdir/$$.ko
+                $2 $initdir/$$.ko && echo "$_modname"
+                rm -f $initdir/$$.ko
+                ;;
+        esac
+    done
+)
+find_kernel_modules_by_path () (
+    if ! [[ $hostonly ]]; then
+        find "$KERNEL_MODS/kernel/$1" "$KERNEL_MODS/extra" "$KERNEL_MODS/weak-updates" \
+          -name "*.ko" -o -name "*.ko.gz" -o -name "*.ko.xz" 2>/dev/null
+    else
+        cut -d " " -f 1 </proc/modules \
+        | xargs modinfo -F filename -k $KERNEL_VER 2>/dev/null
+    fi
+)
+
+filter_kernel_modules () {
+    filter_kernel_modules_by_path  drivers  "$1"
+}
+
+find_kernel_modules () {
+    find_kernel_modules_by_path  drivers
+}
+
+# instmods [-c] <kernel module> [<kernel module> ... ]
+# instmods [-c] <kernel subsystem>
+# install kernel modules along with all their dependencies.
+# <kernel subsystem> can be e.g. "=block" or "=drivers/usb/storage"
+instmods() {
+    [[ $no_kernel = yes ]] && return
+    # called [sub]functions inherit _fderr
+    local _fderr=9
+    local _check=no
+    if [[ $1 = '-c' ]]; then
+        _check=yes
+        shift
+    fi
+
+    function inst1mod() {
+        local _ret=0 _mod="$1"
+        case $_mod in
+            =*)
+                if [ -f $KERNEL_MODS/modules.${_mod#=} ]; then
+                    ( [[ "$_mpargs" ]] && echo $_mpargs
+                      cat "${KERNEL_MODS}/modules.${_mod#=}" ) \
+                    | instmods
+                else
+                    ( [[ "$_mpargs" ]] && echo $_mpargs
+                      find "$KERNEL_MODS" -path "*/${_mod#=}/*" -printf '%f\n' ) \
+                    | instmods
+                fi
+                ;;
+            --*) _mpargs+=" $_mod" ;;
+            i2o_scsi) return ;; # Do not load this diagnostic-only module
+            *)
+                _mod=${_mod##*/}
+                # if we are already installed, skip this module and go on
+                # to the next one.
+                [[ -f "$initdir/.kernelmodseen/${_mod%.ko}.ko" ]] && return
+
+                if [[ $omit_drivers ]] && [[ "$1" =~ $omit_drivers ]]; then
+                    dinfo "Omitting driver ${_mod##$KERNEL_MODS}"
+                    return
+                fi
+                # If we are building a host-specific initramfs and this
+                # module is not already loaded, move on to the next one.
+                [[ $hostonly ]] && ! grep -qe "\<${_mod//-/_}\>" /proc/modules \
+                    && ! echo $add_drivers | grep -qe "\<${_mod}\>" \
+                    && return
+
+                # We use '-d' option in modprobe only if modules prefix path
+                # differs from default '/'.  This allows us to use Dracut with
+                # old version of modprobe which doesn't have '-d' option.
+                local _moddirname=${KERNEL_MODS%%/lib/modules/*}
+                [[ -n ${_moddirname} ]] && _moddirname="-d ${_moddirname}/"
+
+                # ok, load the module, all its dependencies, and any firmware
+                # it may require
+                for_each_kmod_dep install_kmod_with_fw $_mod \
+                    --set-version $KERNEL_VER ${_moddirname} $_mpargs
+                ((_ret+=$?))
+                ;;
+        esac
+        return $_ret
+    }
+
+    function instmods_1() {
+        local _mod _mpargs
+        if (($# == 0)); then  # filenames from stdin
+            while read _mod; do
+                inst1mod "${_mod%.ko*}" || {
+                    if [ "$_check" = "yes" ]; then
+                        dfatal "Failed to install $_mod"
+                        return 1
+                    fi
+                }
+            done
+        fi
+        while (($# > 0)); do  # filenames as arguments
+            inst1mod ${1%.ko*} || {
+                if [ "$_check" = "yes" ]; then
+                    dfatal "Failed to install $1"
+                    return 1
+                fi
+            }
+            shift
+        done
+        return 0
+    }
+
+    local _ret _filter_not_found='FATAL: Module .* not found.'
+    set -o pipefail
+    # Capture all stderr from modprobe to _fderr. We could use {var}>...
+    # redirections, but that would make dracut require bash4 at least.
+    eval "( instmods_1 \"\$@\" ) ${_fderr}>&1" \
+    | while read line; do [[ "$line" =~ $_filter_not_found ]] && echo $line || echo $line >&2 ;done | derror
+    _ret=$?
+    set +o pipefail
+    return $_ret
+}
 
 # inst_libdir_file [-n <pattern>] <file> [<file>...]
 # Install a <file> located on a lib directory to the initramfs image
@@ -574,10 +1094,6 @@ inst_libdir_file() {
     fi
 }
 
-check_qemu() {
-    command -v qemu-kvm &>/dev/null && [[ -c /dev/kvm ]]
-}
-
 check_nspawn() {
     [[ -d /sys/fs/cgroup/systemd ]]
 }
@@ -599,6 +1115,7 @@ do_test() {
     done
 
     import_testdir
+    import_initdir
 
     while (($# > 0)); do
         case $1 in